package com.brilliance.swift.mt2mx.camt029001.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt029001.AbstractMt2MxCamt029001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field76;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.List;
import java.util.Map;

public class Camt029001Parse76Field extends AbstractMt2MxCamt029001ParseField {

    private static final String NAME = "76";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag76 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag76 != null) {
            Field76 field76 = (Field76)tag76.asField();
            Map<String, Object> txInfAndStsMaps = getTxInfAndStsMaps();
            List<String> lines = field76.getLines();
            String sts = mt_To_mxField76(lines, txInfAndStsMaps);
            if("CNCL".equals(sts)||"PDCR".equals(sts)||"RJCR".equals(sts)){
                stsMaps.put("conf",sts);
            }else {
                buildSTErrorInfo(ERROR.T20093, "Block4:76:", null);
            }
        }
    }
}
