package com.brilliance.swift.mt2mx.camt052001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.mt2mx.AbstractMt2MxCreator;
import com.brilliance.swift.mt2mx.Mt2MxParseField;
import com.brilliance.swift.mt2mx.camt052001.impl.*;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Mt2MxCamt052001Creator extends AbstractMt2MxCreator {

    @Override
    public void preProcess() {
        super.preProcess();
        jsonMaps.put("identifier", "camt.052.001.08");
        Map<String, Object> appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        appHdrMaps.put("msgDefIdr", "camt.052.001.08");
        AbstractMT abstractMT = context.get(AbstractMT.class);

        //初始化转换和不需要BLOCK4的转换
        Map<String, Object> bkToCstmrAcctRptMaps = new HashMap<>();
        jsonMaps.put("bkToCstmrAcctRpt", bkToCstmrAcctRptMaps);
        Map<String, Object> grpHdrMaps = new HashMap<>();
        bkToCstmrAcctRptMaps.put("grpHdr", grpHdrMaps);
        grpHdrMaps.put("creDtTm", getCreateDateStr());

        Map<String, Object> rptMaps = new HashMap<>();
        JSONArray rptJsonArray = new JSONArray();
        rptJsonArray.add(rptMaps);
        bkToCstmrAcctRptMaps.put("rpt", rptJsonArray);
        JSONArray ntryJsonArray = new JSONArray();
        Map<String, Object> ntryMaps = new HashMap<>();
        rptMaps.put("ntry",ntryJsonArray);
        ntryJsonArray.add(ntryMaps);
        Map<String, Object> stsMaps = new HashMap<>();
        ntryMaps.put("sts",stsMaps);
        stsMaps.put("cd","BOOK");
        Map<String, Object> bkTxCdMaps = new HashMap<>();
        ntryMaps.put("bkTxCd",bkTxCdMaps);
        Map<String, Object> prtryMaps = new HashMap<>();
        bkTxCdMaps.put("prtry",prtryMaps);
        prtryMaps.put("cd", Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        prtryMaps.put("issr",Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);

    }

    @Override
    public List<Mt2MxParseField> getParseFieldList() {
        List<Mt2MxParseField> list = new ArrayList<>();
        list.add(new Camt052001Parse13DField());
        list.add(new Camt052001Parse20Field());
        list.add(new Camt052001Parse21Field());
        list.add(new Camt052001Parse25Field());
        list.add(new Camt052001Parse28CField());
        list.add(new Camt052001Parse34FField());
        list.add(new Camt052001Parse61Field());
        list.add(new Camt052001Parse90CField());
        list.add(new Camt052001Parse90DField());
        return list;
    }
}
