package com.brilliance.swift.mt2mx.camt052001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt052001.AbstractMt2MxCamt052001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field90D;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Camt052001Parse90DField extends AbstractMt2MxCamt052001ParseField {

    private static final String NAME = "90D";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag90D = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag90D != null) {
            Field90D field90D = (Field90D)tag90D.asField();
            Map<String, Object> txsSummryMaps = null;
            if (rptMaps.containsKey("txsSummry")) {
                txsSummryMaps = (Map<String, Object>) rptMaps.get("txsSummry");
            } else {
                txsSummryMaps = new HashMap<>();
                rptMaps.put("txsSummry",txsSummryMaps);
            }
            Map<String, Object> ttlDbtNtriesMaps = null;
            if (txsSummryMaps.containsKey("ttlDbtNtries")) {
                ttlDbtNtriesMaps = (Map<String, Object>) rptMaps.get("ttlDbtNtries");
            } else {
                ttlDbtNtriesMaps = new HashMap<>();
                txsSummryMaps.put("ttlDbtNtries",ttlDbtNtriesMaps);
            }
            ttlDbtNtriesMaps.put("nbOfNtries",field90D.getNumber());
            String sum = field90D.getAmount();
            ttlDbtNtriesMaps.put("sum",sum.substring(0,sum.length()-1));
        }
    }
}
