package com.brilliance.swift.mt2mx.camt054001;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.mt2mx.AbstractMt2MxParseField;

import java.util.HashMap;
import java.util.Map;

public abstract class AbstractMt2MxCamt054001ParseField extends AbstractMt2MxParseField {

    protected Map<String, Object> appHdrMaps = null;

    protected Map<String, Object> grpHdrMaps = null;

    protected Map<String, Object> ntfctnMaps = null;

    @Override
    public void initJsonMaps() {
        super.initJsonMaps();
        appHdrMaps = (Map<String, Object>)jsonMaps.get("appHdr");
        Map<String, Object> bkToCstmrDbtCdtNtfctnMaps = (Map<String, Object>)jsonMaps.get("bkToCstmrDbtCdtNtfctn");
        grpHdrMaps = (Map<String, Object>)bkToCstmrDbtCdtNtfctnMaps.get("grpHdr");
        JSONArray ntfctnJsonArray = (JSONArray) bkToCstmrDbtCdtNtfctnMaps.get("ntfctn");
        ntfctnMaps = (Map<String, Object>)ntfctnJsonArray.get(0);

    }
    public Map<String, Object> getTransactionDetails(){
        Map<String, Object> ntryMaps = null;
        JSONArray ntryJsonArray = null;
        Map<String, Object> ntryDtlsMaps = null;
        JSONArray ntryDtlsJsonArray = null;
        Map<String, Object> txDtlsMaps = null;
        JSONArray txDtlsJsonArray = null;
        if(ntfctnMaps.containsKey("ntry")){
            ntryJsonArray = (JSONArray) ntfctnMaps.get("ntry");
            if(ntryJsonArray!=null){
                if (ntryJsonArray.size()>0) {
                    ntryMaps = (Map<String, Object>)ntryJsonArray.get(0);
                } else {
                    ntryMaps = new HashMap<>();
                    ntryJsonArray.add(ntryMaps);
                }
            }
        }else {
            ntryJsonArray = new JSONArray();
            ntryMaps = new HashMap<>();
            ntfctnMaps.put("ntry",ntryJsonArray);
            ntryJsonArray.add(ntryMaps);
        }
        if(ntryMaps!=null){
            if(ntryMaps.containsKey("ntryDtls")){
                ntryDtlsJsonArray = (JSONArray) ntryMaps.get("ntryDtls");
                if(ntryDtlsJsonArray!=null){
                    if (ntryDtlsJsonArray.size()>0) {
                        ntryDtlsMaps = (Map<String, Object>)ntryDtlsJsonArray.get(0);
                    } else {
                        ntryDtlsMaps = new HashMap<>();
                        ntryDtlsJsonArray.add(ntryDtlsMaps);
                    }
                }
            }else {
                ntryDtlsJsonArray = new JSONArray();
                ntryDtlsMaps = new HashMap<>();
                ntryMaps.put("ntryDtls",ntryDtlsJsonArray);
                ntryDtlsJsonArray.add(ntryDtlsMaps);
            }
            if(ntryDtlsMaps!=null){
                if(ntryDtlsMaps.containsKey("txDtls")){
                    txDtlsJsonArray = (JSONArray) ntryDtlsMaps.get("txDtls");
                    if(txDtlsJsonArray!=null){
                        if (txDtlsJsonArray.size()>0) {
                            txDtlsMaps = (Map<String, Object>)txDtlsJsonArray.get(0);
                        } else {
                            txDtlsMaps = new HashMap<>();
                            txDtlsJsonArray.add(txDtlsMaps);
                        }
                    }
                }else {
                    txDtlsJsonArray = new JSONArray();
                    txDtlsMaps = new HashMap<>();
                    ntryDtlsMaps.put("txDtls",txDtlsJsonArray);
                    txDtlsJsonArray.add(txDtlsMaps);
                }
            }
        }
        return txDtlsMaps;
    }
}
