package com.brilliance.swift.mt2mx.camt054001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt054001.AbstractMt2MxCamt054001ParseField;
import com.brilliance.swift.util.DateUtil;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field32A;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.text.ParseException;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

public class Camt054001Parse32AField extends AbstractMt2MxCamt054001ParseField {

    private static final String NAME = "32A";

    @Override
    public void parseField() throws SwiftException {
        try {
            AbstractMT abstractMT = context.get(AbstractMT.class);
            Tag tag32A = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
            if (tag32A != null) {
                Field32A field32A = (Field32A)tag32A.asField();
                Date date = DateUtil.parseDate("20"+field32A.getDate(), "yyyyMMdd");
                String dateStr = DateUtil.format(date, "yyyy-MM-dd");
                Map<String, Object> ntryMaps = null;
                JSONArray ntryJsonArray = null;
                if(ntfctnMaps.containsKey("ntry")){
                    ntryJsonArray = (JSONArray) ntfctnMaps.get("ntry");
                    if(ntryJsonArray!=null){
                        if (ntryJsonArray.size()>0) {
                            ntryMaps = (Map<String, Object>)ntryJsonArray.get(0);
                        } else {
                            ntryMaps = new HashMap<>();
                            ntryJsonArray.add(ntryMaps);
                        }
                    }
                }else {
                    ntryJsonArray = new JSONArray();
                    ntryMaps = new HashMap<>();
                    ntfctnMaps.put("ntry",ntryJsonArray);
                    ntryJsonArray.add(ntryMaps);
                }
                Map<String, Object> valDtMaps = new HashMap<>();
                ntryMaps.put("valDt",valDtMaps);
                valDtMaps.put("dt",dateStr);
                Map<String, Object> txDtlsMaps = getTransactionDetails();
                Map<String, Object> rltdDtsMaps = new HashMap<>();
                txDtlsMaps.put("rltdDts",rltdDtsMaps);
                rltdDtsMaps.put("intrBkSttlmDt",dateStr);
                Map<String, Object> amtMaps = null;
                Map<String, Object> txDtlsamtMaps = null;
                if(ntryMaps.containsKey("amt")){
                    amtMaps = (Map<String, Object>)ntryMaps.get("amt");
                }else {
                    amtMaps = new HashMap<>();
                    ntryMaps.put("amt", amtMaps);
                }
                if(txDtlsMaps.containsKey("amt")){
                    txDtlsamtMaps = (Map<String, Object>)txDtlsMaps.get("amt");
                }else {
                    txDtlsamtMaps = new HashMap<>();
                    txDtlsMaps.put("amt", txDtlsamtMaps);
                }
                amtMaps.put("value", field32A.amount());
                txDtlsamtMaps.put("value", field32A.amount());
                amtMaps.put("ccy", field32A.getCurrency());
                txDtlsamtMaps.put("ccy", field32A.getCurrency());
            }
        } catch (ParseException e) {
            throw  new SwiftException("ERROR", e.getMessage());
        }
    }
}
