package com.brilliance.swift.mt2mx.camt056001.impl;

import com.alibaba.fastjson.JSONArray;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt056001.AbstractMt2MxCamt056001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.field.Field79;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Camt056001Parse79Field extends AbstractMt2MxCamt056001ParseField {

    private static final String NAME = "79";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag79 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        Map<String, Object> txInfMaps = getTxInfMaps();
        if (tag79 != null) {
            Field79 field79 = (Field79)tag79.asField();
            List<String> lines = field79.getLines();
            mt_To_mxField79(lines,txInfMaps);
        }else {
            JSONArray cxlRsnInfJSONArray = null;
            Map<String,Object> cxlRsnInfMaps = null;
            if(txInfMaps.containsKey("cxlRsnInf")){
                cxlRsnInfJSONArray = (JSONArray)txInfMaps.get("cxlRsnInf");
                if(cxlRsnInfJSONArray.size()>0){
                    cxlRsnInfMaps = (Map<String,Object>)cxlRsnInfJSONArray.get(0);
                }else {
                    cxlRsnInfMaps = new HashMap<>();
                    cxlRsnInfJSONArray.add(cxlRsnInfMaps);
                }
            }else {
                cxlRsnInfJSONArray = new JSONArray();
                cxlRsnInfMaps = new HashMap<>();
                txInfMaps.put("cxlRsnInf",cxlRsnInfJSONArray);
                cxlRsnInfJSONArray.add(cxlRsnInfMaps);
            }
            Map<String,Object> rsnMaps = new HashMap<>();
            cxlRsnInfMaps.put("rsn",rsnMaps);
            rsnMaps.put("cd","NARR");
            JSONArray addtlInfJSONArray = new JSONArray();
            cxlRsnInfMaps.put("addtlInf",addtlInfJSONArray);
            addtlInfJSONArray.add(Mx2MtConstants.MT_TO_MX_DEFAULT_VALUE);
        }
    }
}
