package com.brilliance.swift.mx2mt.mt196296.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 *
 */
public class Field11RGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "11R";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String orgnlMsgNmId = "";
        String date = "";
        boolean boolean1 = false;
        boolean boolean2 = false;
        String mtType = getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.OrgnlGrpInf.OrgnlMsgNmId");
        String dateStr = getXmlNodeValue(bodyHdrParentElementName, document, "CxlDtls.TxInfAndSts.OrgnlGrpInf.OrgnlCreDtTm");
        if (StringUtil.isNotEmpty(mtType)) {
            if(StringUtil.isNotEmpty(mtType)){
                if(mtType.startsWith("pacs.008")){
                    orgnlMsgNmId =  "103";
                }else if(mtType.startsWith("pacs.003")){
                    orgnlMsgNmId = "104";
                }else if(mtType.startsWith("pacs.009")){
                    orgnlMsgNmId = "202";
                }else if(mtType.startsWith("pacs.010")){
                    orgnlMsgNmId = "204";
                }else if(mtType.matches("MT10[0-9]{1}")){
                    orgnlMsgNmId = mtType.substring(2);
                }else if(mtType.matches("MT20[0-9]{1}")){
                    orgnlMsgNmId = mtType.substring(2);
                }else {
                    orgnlMsgNmId = "202";
                    boolean1 = true;
                }
            }
        }
        if(StringUtil.isNotEmpty(dateStr)){
            if(dateStr.length()>0){
                date = mXToMTDate(dateStr);
            }else {
                date = "993112";
                boolean2 = true;
            }
        }
        if(boolean1&&boolean2){

        }else {
            tags.add(new Tag(name, orgnlMsgNmId+Mx2MtConstants.NEW_LINE+date));
            if(boolean1){
                buildSTErrorInfo(ERROR.T20083,"BLOCK4/:11R:",null);
            }
        }

    }
}
