package com.brilliance.swift.mx2mt.mt202Retn.impl;


import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 *
 */
public class Field52AGenerate extends AbstractMx2MtTagsGenerate {

    private static String name_A = "52A";

    private static String name_D = "52D";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/52a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        int dbtrPartyCount = getXmlNodeCounts(bodyHdrParentElementName, document, "TxInf.RtrChain.Dbtr.Pty");
        if (dbtrPartyCount > 0) {
            buildSTErrorInfo(ERROR.T20048, null, null);
        }
        String agtPath = bodyHdrParentElementName + ".TxInf.RtrChain.Dbtr.Agt";
        String bicCode = mx_to_mtBICFI(agtPath);
        String mtClearSystemId = mx_to_mtClearingIdentifier(agtPath);
        String value = "";
        if (StringUtil.isNotEmpty(bicCode)) {
            if (StringUtil.isNotEmpty(mtClearSystemId)) {
                value = mtClearSystemId + Mx2MtConstants.NEW_LINE + bicCode;
            } else {
                value = bicCode;
            }
            tags.add(new Tag(name_A, value));
        } else {
            String name = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.RtrChain.Dbtr.Agt.FinInstnId.Nm");
            String countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "TxInf.RtrChain.Dbtr.Agt.FinInstnId.PstlAdr.Ctry");
            int addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "TxInf.RtrChain.Dbtr.Agt.FinInstnId.PstlAdr.AdrLine");
            String mtNameAddress = "";
            if (addressLineCount > 0) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".TxInf.RtrChain.Dbtr.Agt.FinInstnId");
            } else if (StringUtil.isNotEmpty(countryCode)) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndStructuredAddress(bodyHdrParentElementName+ ".TxInf.RtrChain.Dbtr.Agt.FinInstnId", false);
            } else if (StringUtil.isNotEmpty(name)) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".TxInf.RtrChain.Dbtr.Agt.FinInstnId");
            }
            if (StringUtil.isEmpty(mtNameAddress)) return;//如果name和地址不存在，返回。
            if (StringUtil.isNotEmpty(mtClearSystemId)) {
                value = mtClearSystemId + Mx2MtConstants.NEW_LINE + mtNameAddress;
            } else {
                value = mtNameAddress;
            }
            value = mx_to_mtStartingLineCharacter(value, "Block4/:52D:");
            tags.add(new Tag(name_D, value));
        }
    }

}
