package com.brilliance.swift.mx2mt.mt202cov202.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**
 */
public class Field58AGenerate extends AbstractMx2MtTagsGenerate {


    private static String name_A = "58A";

    private static String name_D = "58D";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/58a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        boolean flag = exist56a57aStartWithFWRT(tags);
        String bicCode = mx_to_mtBICFI(bodyHdrParentElementName + ".CdtTrfTxInf.Cdtr");
        String account = mx_to_mtAccount(bodyHdrParentElementName + ".CdtTrfTxInf.CdtrAcct");
        String mtClearSystemId = mx_to_mtClearingIdentifier(bodyHdrParentElementName + ".CdtTrfTxInf.Cdtr");
        String mtClearChannelId = mx_to_mtClearingIdentifierAndChannel(bodyHdrParentElementName + ".CdtTrfTxInf.Cdtr");
        String mtAccount = "";
        String value = "";
        if (StringUtil.isNotEmpty(bicCode)) {
            if (StringUtil.isNotEmpty(account)) {
                mtAccount = account;
            } else if (StringUtil.isNotEmpty(mtClearChannelId)){
                mtAccount = mtClearChannelId;
            } else {
                mtAccount = mtClearSystemId;
            }
            //mapping转换文档 Translation Post Conditions -> POSTC004
            if (flag && StringUtil.isNotEmpty(mtAccount) && (mtAccount.startsWith("//FW") || mtAccount.startsWith("//RT"))) {
                if (StringUtil.isEmpty(mtClearSystemId) || mtClearSystemId.startsWith("//FW")) {
                    mtAccount = "";
                    buildSTErrorInfo(ERROR.T20224, "Block4/:"+name_A+":", null);
                } else {
                    mtAccount = mtClearSystemId;
                }
            }
            if (StringUtil.isNotEmpty(mtAccount)) {
                value = mtAccount + Mx2MtConstants.NEW_LINE + bicCode;
            } else {
                value = bicCode;
            }
            tags.add(new Tag(name_A, value));
        } else {
            String name = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.Cdtr.FinInstnId.Nm");
            String countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "CdtTrfTxInf.Cdtr.FinInstnId.PstlAdr.Ctry");
            int addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "CdtTrfTxInf.Cdtr.FinInstnId.PstlAdr.AdrLine");
            String mtNameAddress = "";
            if (addressLineCount > 0) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".CdtTrfTxInf.Cdtr.FinInstnId");
            } else if (StringUtil.isNotEmpty(countryCode)) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndStructuredAddress(bodyHdrParentElementName+ ".CdtTrfTxInf.Cdtr.FinInstnId", false);
            } else if (StringUtil.isNotEmpty(name)) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(bodyHdrParentElementName+ ".CdtTrfTxInf.Cdtr.FinInstnId");
            }
            if (StringUtil.isEmpty(mtNameAddress)) return;//如果name和地址不存在，返回。
            if (StringUtil.isNotEmpty(mtClearChannelId)) {
                mtAccount = mtClearChannelId;
            } else if (StringUtil.isNotEmpty(mtClearSystemId)) {
                mtAccount = mtClearSystemId;
            } else {
                mtAccount = account;
            }
            //mapping转换文档 Translation Post Conditions -> POSTC004
            if (flag && StringUtil.isNotEmpty(mtAccount) && (mtAccount.startsWith("//FW") || mtAccount.startsWith("//RT"))) {
                if (StringUtil.isEmpty(mtClearSystemId) || mtClearSystemId.startsWith("//FW")) {
                    mtAccount = "";
                    buildSTErrorInfo(ERROR.T20224, "Block4/:"+name_A+":", null);
                } else {
                    mtAccount = mtClearSystemId;
                }
            }
            if (StringUtil.isNotEmpty(mtAccount)) {
                value = mtAccount + Mx2MtConstants.NEW_LINE + mtNameAddress;
            } else {
                value = mtNameAddress;
            }
            value = mx_to_mtStartingLineCharacter(value, "Block4/:58D:");
            tags.add(new Tag(name_D, value));
        }
    }

    /**
     * 56a 是否以 //FW or //RT 开始
     * 否则 57a 是否以 //FW or //RT 开始
     * @param tags
     * @return
     */
    private boolean exist56a57aStartWithFWRT(List<Tag> tags) {
        boolean flag = false;
        if (tags != null && tags.size() > 0) {
            for (int i=0; i<tags.size(); i++) {
                Tag tag = tags.get(i);
                if ("56A".equals(tag.getName()) || "56D".equals(tag.getName())) {
                    String value = tag.getValue();
                    if (value.startsWith("//FW") || value.startsWith("//RT")) {
                        flag = true;
                        break;
                    }
                }
            }
        }
        if (!flag) {
            if (tags != null && tags.size() > 0) {
                for (int i=0; i<tags.size(); i++) {
                    Tag tag = tags.get(i);
                    if ("57A".equals(tag.getName()) || "57D".equals(tag.getName())) {
                        String value = tag.getValue();
                        if (value.startsWith("//FW") || value.startsWith("//RT")) {
                            flag = true;
                            break;
                        }
                    }
                }
            }
        }
        return flag;
    }
}

