package com.brilliance.swift.mx2mt.mt210.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field30Generate extends AbstractMx2MtTagsGenerate {

    private static String name = "30";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String mxDate = "";
        String mtDate = "";
        String valDt = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.XpctdValDt");
        if(StringUtil.isNotEmpty(valDt)){
            mxDate = valDt;
        }else {
            mxDate = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Itm("+0+").XpctdValDt");
        }
        if(StringUtil.isNotEmpty(mxDate)){
            mtDate = mXToMTDate(mxDate);
        }else {
            mtDate = "991231";
            buildSTErrorInfo(ERROR.T20062, "BLOCK4/:30:","");
        }
        tags.add(new Tag(name, mtDate));
    }
}
