package com.brilliance.swift.mx2mt.mt900910.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.mx2mt.Mx2MtContextIdentifier;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mx.dic.CreditDebitCode;

import java.util.List;

//<Ntfctn><Ntry><NtryDtls><TxDtls><RltdPties><Dbtr><Pty><Id><OrgId><AnyBIC>
public class Field52aFor910Generate extends AbstractMx2MtTagsGenerate {


    private static String name_A = "52A";

    private static String name_D = "52D";

    @Override
    public void tagGenerate() throws SwiftException {
        context.set(Mx2MtContextIdentifier.MX_TO_MT_ERROR_LOCATION, "Block4/52a");
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String cdtDbtInd = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Ntry.CdtDbtInd");
        if (!CreditDebitCode.CRDT.value().equals(cdtDbtInd)) {
            return;
        }
        String agtPath = bodyHdrParentElementName + ".Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt";
        String bicCode = mx_to_mtBICFI(agtPath);
        String mtClearSystemId = mx_to_mtClearingIdentifier(agtPath);
        String value = "";
        if (StringUtil.isNotEmpty(bicCode)) {
            if (StringUtil.isNotEmpty(mtClearSystemId)) {
                value = mtClearSystemId + Mx2MtConstants.NEW_LINE + bicCode;
            } else {
                value = bicCode;
            }
            tags.add(new Tag(name_A, value));
        } else {
            String name = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt.FinInstnId.Nm");
            String countryCode = getXmlNodeValue(bodyHdrParentElementName, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt.FinInstnId.PstlAdr.Ctry");
            int addressLineCount = getXmlNodeCounts(bodyHdrParentElementName, document, "Ntfctn.Ntry.NtryDtls.TxDtls.RltdAgts.DbtrAgt.FinInstnId.PstlAdr.AdrLine");
            String mtNameAddress = "";
            if (addressLineCount > 0) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(agtPath + ".FinInstnId");
            } else if (StringUtil.isNotEmpty(countryCode)) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndStructuredAddress(agtPath + ".FinInstnId", false);
            } else if (StringUtil.isNotEmpty(name)) {
                mtNameAddress = mx_to_mtFinancialInstitutionNameAndUnstructuredAddress(agtPath + ".FinInstnId");
            }
            if (StringUtil.isEmpty(mtNameAddress)) return;//如果name和地址不存在，返回。
            if (StringUtil.isNotEmpty(mtClearSystemId)) {
                value = mtClearSystemId + Mx2MtConstants.NEW_LINE + mtNameAddress;
            } else {
                value = mtNameAddress;
                if (Mx2MtConstants.MX_TO_MT_DEFAULT_VALUE.equals(value) && exist50a(tags)) {
                    buildSTErrorInfo(ERROR.T20064, "Block4/52a", null);
                    return;
                }
            }
            tags.add(new Tag(name_D, value));
        }
    }

    /**
     * 判断是否存在50a
     * @param tags
     * @return
     */
    private boolean exist50a(List<Tag> tags) {
        boolean flag = false;
        if (tags != null && tags.size() > 0) {
            for (int i=0; i<tags.size(); i++) {
                Tag tag = tags.get(i);
                if ("50A".equals(tag.getName())
                        || "50F".equals(tag.getName())
                        || "50K".equals(tag.getName())) {
                    flag = true;
                    break;
                }
            }
        }
        return flag;
    }
}
