package com.brilliance.swift.mx2mt.mt941942.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.util.List;

/**

 */
public class Field28CGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "28C";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String num = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.LglSeqNb");
        if(StringUtil.isEmpty(num)||num.length()>5){
            num = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.ElctrncSeqNb");
            if(StringUtil.isEmpty(num)||num.length()>5){
                buildSTErrorInfo(ERROR.T20103, "BLOCK4/:28C:", bodyHdrParentElementName+"Rpt.ElctrncSeqNb");
                return;
            }
        }
        String pageNum = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.RptPgntn.PgNb");
        String mt = num + "/" + pageNum;
        tags.add(new Tag(name,mt));
    }
}
