package com.brilliance.swift.mx2mt.mt941942.impl;

import com.brilliance.swift.constants.ERROR;
import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mx2mt.AbstractMx2MtTagsGenerate;
import com.brilliance.swift.util.NumberUtil;
import com.brilliance.swift.util.StringUtil;
import com.prowidesoftware.swift.model.SwiftMessage;
import com.prowidesoftware.swift.model.Tag;

import java.math.BigDecimal;
import java.util.List;

/**

 */
public class Field90DGenerate extends AbstractMx2MtTagsGenerate {

    private static String name = "90D";

    @Override
    public void tagGenerate() throws SwiftException {
        SwiftMessage swiftMessage = context.get(SwiftMessage.class);
        List<Tag> tags = swiftMessage.getBlock4().getTags();
        String sumd = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.TxsSummry.TtlDbtNtries.Sum");
        String nbOfNtries = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.TxsSummry.TtlDbtNtries.NbOfNtries");
        if(StringUtil.isNotEmpty(sumd)&&StringUtil.isNotEmpty(nbOfNtries)) {
            String currency = getXmlNodeValue(bodyHdrParentElementName, document, "Rpt.Acct.Ccy");
            String amt = NumberUtil.formatAmt(new BigDecimal(sumd), currency);
            if (NumberUtil.judgeAmtStrExceedLength(amt, 14)) {
                buildSTErrorInfo(ERROR.T20120, "BLOCK4/:90D:", amt);
            } else if(nbOfNtries.length()>5){
                buildSTErrorInfo(ERROR.T20119, "BLOCK4/:90D:", nbOfNtries);
            } else {
                tags.add(new Tag(name,nbOfNtries+currency+amt));
            }
        }else {
            buildSTErrorInfo(ERROR.T20121, "BLOCK4/:90D:","");
        }
    }
}
