package com.brilliance.mt2mx.pacs008001;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.constants.Mx2MtConstants;
import com.brilliance.swift.util.StringUtil;
import com.brilliance.swift.vo.SwiftTranslationErrorInfo;
import com.brilliance.swift.vo.SwiftTranslationReport;
import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.util.List;

public class Test {

    public static void main(String[] args) throws IOException {
        //File file = new File(System.getProperty("user.dir")+"\\swiftCore\\src\\main\\resources\\swiftTxt\\Mt103.txt");
        File file = new File("d:/test/MT103.txt");
        String mtStr = FileUtils.readFileToString(file);
        SwiftTranslationReport str = SwiftTransfer.mt2MxPlus(mtStr, "D:/test/mt2mx/pacs00800108.xml", null);
        if (str != null) {
            List<SwiftTranslationErrorInfo> errorInfos = str.getErrorInfos();
            if (errorInfos != null && errorInfos.size() > 0) {
                for (int i=0; i<errorInfos.size(); i++) {
                    SwiftTranslationErrorInfo errorInfo = errorInfos.get(i);
                    String location = errorInfo.getLocation();
                    String errorType = errorInfo.getErrorType();
                    String description = errorInfo.getDescription();
                    System.out.println(location + Mx2MtConstants.NEW_LINE + "-" + errorType + ":" + description);
                    String originalValue = errorInfo.getOriginalValue();
                    if (StringUtil.isNotEmpty(originalValue)) {
                        System.out.println(originalValue);
                    }
                }
            }
            System.out.println(str.getMessage());
        }
    }
}
